Subject: Re: 802.1Q VLAN random tag injected when vlan configured on forcedeth interface

From: "Ruslan N. Marchenko" <[email-masked]>
Date: Wed, 31 Aug 2011 15:10:34 +0200

On Tue, Aug 30, 2011 at 04:42:42PM +0200, Eric Dumazet wrote:
> Le mardi 30 août 2011 à 16:23 +0200, Ruslan N. Marchenko a écrit :
> > On Tue, Aug 30, 2011 at 03:46:24PM +0200, Ruslan N. Marchenko wrote:
> > > On Tue, Aug 30, 2011 at 03:23:48PM +0200, Eric Dumazet wrote:
> > > > 
> > > > What kernel version are you using ?
> > > > 
> > > Oh, sorry for missing it, it runs on 
> > > Linux ruff.mobi 2.6.38-11-generic #48-Ubuntu SMP Fri Jul 29 19:05:14 UTC 2011 i686 i686 i386 GNU/Linux
> > > 
> > > Just fyi - the openwrt box to which it is connected is 
> > > Linux OpenWrt 2.6.39.2 #2 Fri Aug 12 09:36:23 EEST 2011 mips GNU/Linux
> > > although packet drop happens even if there're no vlans configured on remote side.
> > > 
> > Here is double-tag sample:
> > 16:20:31.151268 e0:46:9a:4e:88:1d > 00:26:18:40:21:62, ethertype 802.1Q (0x8100), length 106: vlan 2112, p 7, ethertype 802.1Q, vlan 6, p 0, ethertype IPv4, [|ip]
> >         0x0000:  0026 1840 2162 e046 9a4e 881d 8100 e840
> >         0x0010:  8100 0006 0800 4500 0054 abec 0000
> > 
> > 
> 
> Latest kernel should be fine. Some patches need to be backported by
> Ubuntu team, if you can test them.
> 
> commit 9331db4f00cfee8a79d2147ac83723ef436b9759
> Author: Jiri Pirko <[email-masked]>
> Date:   Wed Aug 17 23:50:37 2011 -0700
> 
>     forcedeth: call vlan_mode only if hw supports vlans
>     
>     If hw does not support vlans, dont call nv_vlan_mode because it has no point.
>     I believe that this should fix issues on older non-vlan supportive
>     chips (like Ingo has).
>     
>     Reported-ty: Ingo Molnar <[email-masked]>
>     Signed-off-by: Jiri Pirko <[email-masked]>
>     Signed-off-by: David S. Miller <[email-masked]>
> 
> commit 0891b0e08937aaec2c4734acb94c5ff8042313bb
> Author: Jiri Pirko <[email-masked]>
> Date:   Tue Jul 26 10:19:28 2011 +0000
> 
>     forcedeth: fix vlans
>     
>     For some reason, when rxaccel is disabled, NV_RX3_VLAN_TAG_PRESENT is
>     still set and some pseudorandom vids appear. So check for
>     NETIF_F_HW_VLAN_RX as well. Also set correctly hw_features and set vlan
>     mode on probe.
>     
>     Signed-off-by: Jiri Pirko <[email-masked]>
>     Signed-off-by: David S. Miller <[email-masked]>
> 
> commit 3326c784c9f492e988617d93f647ae0cfd4c8d09
> Author: Jiri Pirko <[email-masked]>
> Date:   Wed Jul 20 04:54:38 2011 +0000
> 
>     forcedeth: do vlan cleanup
>     
>     - unify vlan and nonvlan rx path
>     - kill np->vlangrp and nv_vlan_rx_register
>     - allow to turn on/off rx vlan accel via ethtool (set_features)
>     
>     Signed-off-by: Jiri Pirko <[email-masked]>
>     Signed-off-by: David S. Miller <[email-masked]>
> 
> 

Thanks Eric for quick hint, atom n270 however is not as fast in compiling kernel :D
I'm trying to backport the patch (and dependencies) and compile kernel with it, takes lot of time though. Will report back and raise a report/request to ubuntu kernel team. Anyway it seems exactly what I have.

Cheers,
Ruslan